#include <Windows.h>
#include "pch.h"
#include "CPlusLibrary.h"

#import "lib/CSharpLibrary.tlb" no_namespace named_guids

ICSharpLibrary* lib = NULL;
int* data = NULL;
bool isWorking = false;
char* name = NULL;

bool Init() {
	HRESULT hr = CoInitializeEx(NULL, tagCOINIT::COINIT_MULTITHREADED);

	if (!SUCCEEDED(hr))
		return false;

	hr = CoCreateInstance(CLSID_CSharpLibrary, NULL, CLSCTX_INPROC_SERVER, IID_ICSharpLibrary, reinterpret_cast<void**>(&lib));

	if (!SUCCEEDED(hr))
		return false;

	return true;
}

int* GetData() {
	auto raw = lib->GetData();
	void* pVoid = NULL;

	HRESULT hr = ::SafeArrayAccessData(raw, &pVoid);

	if (!SUCCEEDED(hr))
		return NULL;
	auto result = reinterpret_cast<int*>(pVoid);

	return result;
}

char* GetName() {
	char str[10];
	strcpy_s(str, lib->GetName());
	name = str;

	return name;
}